<script type='text/JavaScript'>
var action_ajax = null;

function do_action()
{
  var form = document.getElementById('main_form');
  if(!form) return false;

  Forum.show_sys_progress_indicator(true);
  document.location.href = "#moderation";

  if(!action_ajax)
  {
    action_ajax = new Forum.AJAX();

    action_ajax.timeout = TIMEOUT;

    action_ajax.beforestart = function() { break_check_new_messages(); };
    action_ajax.aftercomplete = function(error) { activate_check_new_messages(); };

    action_ajax.onload = function(text, xml)
    {
      try
      {
        var response = JSON.parse(text);

        Forum.handle_response_messages(response);

        if(response.success)
        {
          delay_reload();
          return;
        }
      }
      catch(err)
      {
        Forum.handle_ajax_error(this, err.message, this.last_url, {});
      }

      Forum.show_sys_progress_indicator(false);
    };

    action_ajax.onerror = function(error, url, info)
    {
      Forum.show_sys_progress_indicator(false);

      Forum.handle_ajax_error(this, error, url, info);
    };
  }

  action_ajax.abort();
  action_ajax.resetParams();

  var formData = new FormData(form);

  formData.append('hash', get_protection_hash());
  formData.append('user_logged', user_logged);  
  formData.append('delete_user_rates', "1");

  action_ajax.setFormData(formData);

  action_ajax.request("ajax/process.php");

  return false;
} // do_action
</script>

<!-- BEGIN: forum_bar -->

<div class="forum_bar">
<a href="forums.php"><?php echo_html(text("Forums")); ?></a>

<?php
$display = "style='display:none'";
if(!empty($topics_with_new_count)) $display = "";
?>
<span class="new topics_with_new_indicator" <?php echo($display); ?>>[<a rel="nofollow" href="new_messages.php"><?php echo_html(text("new")); ?>:<span class='topics_with_new_count'><?php echo($topics_with_new_count); ?></span></a>]</span> 

/ <a href="moderation.php"><?php echo_html(text("Moderation")); ?></a> / <span class="topic_title_main"><?php echo_html(text("ModerateRates")); ?></span>
</div>

<!-- END: forum_bar -->

<form action="rate_moderation.php" id="main_form" enctype="multipart/form-data" method="post" onsubmit="return do_action();">

<input type="hidden" id="uid" name="uid" value="<?php echo_html($user_data["id"]); ?>">

<table class="form_table profile_table profile_view_table">

<tr>
<th><?php echo_html(text("ModerateRates")); ?></th>
</tr>

<tr>
<td><?php echo_html(text("UserName")); ?>:</td>
</tr>
<tr>
  <?php
  $online_status = "";
  if(empty($settings["hide_online_status"]) && !empty($user_data["online"]))
  {
    $online_status = "&nbsp;<span class='online_text'>✓</span>";
  }
  ?>
<td><div class="smart_break"><span class="number"><?php echo_html($user_data["user_name"]); ?></span><?php echo($online_status); ?></div></td>
</tr>


<tr>
<td></td>
</tr>
<tr>
<td>

<?php
$rnd = rand(1000, 9000);
$picture = $view_path . "images/guest.jpg";
if(!empty($user_data["avatar"]))
{
  $appendix = "?rnd=$rnd";
  if(!empty($user_data["avatar_ctime"])) $appendix = "?ctime=" . $user_data["avatar_ctime"];

  $picture = escape_html($user_data["avatar"]) . $appendix;
}
?>

<img class="avatar_picture" src="<?php echo($picture); ?>" alt="<?php echo_html(text("Avatar")); ?>"><?php if(val_or_empty($user_data["self_blocked"]) == 2): ?><img class="mourning_band" src="<?php echo($view_path . "images/mourning_band.png"); ?>" alt="<?php echo_html(text("Avatar")); ?>"><?php endif; ?>

</td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><span class="number"><?php echo_html(text("Status")); ?>:</span></td>
</tr>
<tr>
<td>
  <?php if(!empty($user_data["is_admin"])): ?>

    <?php echo_html(text("Administrator")); ?><br>

  <?php elseif(!empty($user_data["moderator"])): ?>

    <div class='moderator_of_forums'><?php echo_html(text("ModeratorOfForums")); ?>:</div>
    <?php foreach($user_data["moderator"] as $fid => $fname):
    $not_preferred = "";
    if(!empty($_SESSION["preferred_forums"]) && empty($_SESSION["preferred_forums"][$fid])) $not_preferred = "not_preferred";
    ?>
    <a href="forum.php?fid=<?php echo_html($fid); ?>" class="<?php echo($not_preferred); ?>"><?php echo_html($fname); ?></a><br>
    <?php endforeach; ?>

  <?php else: ?>

    <?php echo_html(text("RegisteredUser")); ?><br>

  <?php endif; ?>

  <?php if(!empty($user_data["my_profile"])): ?>
  <br><span class="error_text self_blocked"><?php echo_html(text("MyProfile")); ?></span>
  <?php endif; ?>

  <?php if(empty($user_data["activated"])): ?>
  <br><span class="error_text"><?php echo_html(text("NotActivated")); ?></span>
  <?php endif; ?>

  <?php if(empty($user_data["approved"])): ?>
  <br><span class="error_text"><?php echo_html(text("NotApproved")); ?></span>
  <?php endif; ?>

  <?php if(!empty($user_data["hidden"])): ?>
  <br><span class="error_text"><?php echo_html(text("Hidden")); ?></span>
  <?php endif; ?>

  <?php if(empty($user_data["hidden"]) && !empty($user_data["hidden_by_me"])): ?>
  <br><span class="error_text"><?php echo_html(text("HiddenByMe")); ?></span>
  <?php endif; ?>
  
  <?php if(!empty($user_data["hiding_me"])): ?>
  <br><span class="error_text"><?php echo_html(text("HidingMe")); ?></span>
  <?php endif; ?>  
  
  <?php if(!empty($user_data["ignored"])): ?>
  <br><span class="error_text"><?php echo_html(text("Ignored")); ?></span>

    <?php if(!empty($user_data["ignored_comment"])): ?> 
    <div class="ignore_reason">
    <?php echo($user_data["ignored_comment"]); ?>
    </div>
    <?php endif; ?>
  <?php endif; ?>

  <?php if((!$fmanager->is_logged_in() || $fmanager->is_master_admin()) && !empty($user_data["ignores_all_guests"])): ?>
  <br><span class="error_text"><?php echo_html(text("IgnoringGuests")); ?></span>
  <?php elseif(val_or_empty($user_data["ignoring_me"]) == 1): ?>
  <br><span class="error_text"><?php echo_html(text("IgnoringMe")); ?></span>
  <?php elseif(val_or_empty($user_data["ignoring_me"]) == 2): ?>
  <br><span class="error_text"><?php echo_html(text("IgnoringGuestsExcept")); ?></span>
  <?php elseif(val_or_empty($user_data["ignoring_me"]) == 3): ?>
  <br><span class="error_text"><?php echo_html(text("IgnoringNewGuests")); ?></span>
  <?php endif; ?>
  
  <?php 
  $separator = "";
  if(!empty($user_data["blocked"])): 
  $separator = "<br>";
  $class = "";
  $death_sign = "";
  if(val_or_empty($user_data["self_blocked"]) == 1) $class = "self_blocked";
  elseif(val_or_empty($user_data["self_blocked"]) == 2) 
  {
    $class = "author_dead";
    $death_sign = "&nbsp;†";
  }
  ?>
  
  <br><span class="error_text <?php echo($class); ?>"><?php echo_html(empty($user_data["block_expires"]) ? text("Blocked") : sprintf(text("BlockedUntil"), $user_data["block_expires"])); ?><?php echo($death_sign); ?></span>
    <?php if(!empty($user_data["block_time_left"])): ?>
    <span style="color:gray">[<?php echo_html($user_data["block_time_left"]); ?>]</span>
    <?php endif; ?>

  <?php endif; ?>

  <?php if(!empty($user_data["forum_blocked"])): ?>
  <?php echo($separator); ?>
  <br><?php echo_html(text("ForumBlocking")); ?>:<br>
  <?php foreach($user_data["forum_blocked"] as $fid => $forum_data): 
    $not_preferred = "";
    if(!empty($_SESSION["preferred_forums"]) && empty($_SESSION["preferred_forums"][$fid]) && $forum_data["fid_for_url"] != "private") $not_preferred = "not_preferred";
    ?>
    <br><a href="forum.php?fid=<?php echo_html($forum_data["fid_for_url"]); ?>" class="<?php echo($not_preferred); ?>"><?php echo_html($forum_data["name"]); ?></a>
  
    <br><span class="error_text"><?php echo_html(empty($forum_data["block_expires"]) ? text("Blocked") : sprintf(text("BlockedUntil"), $forum_data["block_expires"])); ?></span>
        <?php if(!empty($forum_data["block_time_left"])): ?>
        <span style="color:gray">[<?php echo_html($forum_data["block_time_left"]); ?>]</span>
        <?php endif; ?>
        
  <?php endforeach; ?>
  <?php endif; ?>

</td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("RegistrationDate")); ?>: <span class="number"><?php echo_html(smart_date($user_data["registration_date"])); ?></span></td>
</tr>

<tr>
<td></td>
</tr>

<?php if(empty($settings["hide_online_status"])): ?>
<tr>
<td><?php echo_html(text("LastActivity")); ?>: <span class="number"><?php echo_html($user_data["last_visit_date"]); ?></span></td>
</tr>

<tr>
<td></td>
</tr>
<?php endif; ?>

<tr>
<td><?php echo_html(text("MessagesCount")); ?>: <span class="number"><?php echo_html(format_number($user_data["post_count"])); ?></span></td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("TopicsCount")); ?>: <span class="number"><?php echo_html(format_number($user_data["topic_count"])); ?></span></td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("MessagesPerDay")); ?>: <span class="number"><?php echo_html(format_number($user_data["week_post_count"])); ?></span>
 <span style="color: gray" class="field_comment">(<?php echo_html(text("OverLastWeek")); ?>)</span>
</td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("HitsPerDay")); ?>: <span class="number"><?php echo_html(format_number($user_data["week_view_count"])); ?></span>
 <span style="color: gray" class="field_comment">(<?php echo_html(text("OverLastWeek")); ?>)</span>
</td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("TimeOnlinePerDay")); ?>: <span class="number"><?php echo_html(format_duration($user_data["week_time_online"])); ?></span>
 <span style="color: gray" class="field_comment">(<?php echo_html(text("OverLastWeek")); ?>)</span>
</td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("TimeOnlineLast24Hours")); ?>: <span class="number"><?php echo_html(format_duration($user_data["today_time_online"])); ?></span>
</td>
</tr>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("TimeOnlineTotal")); ?>: <span class="number"><?php echo_html(format_duration($user_data["time_online"])); ?></span>
</td>
</tr>

<?php if(!empty($settings["rates_active"])): ?>

<tr>
<td></td>
</tr>

<tr>
<td><?php echo_html(text("Rating")); ?>: <a href="search_topic.php?do_search=1&post_sort=desc&author_mode=author_liked&author=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="carma_plus"><?php echo_html($user_data["carma_plus"]); ?></a>
<?php if(!empty($settings["dislikes_active"])): ?>
/ <a href="search_topic.php?do_search=1&post_sort=desc&author_mode=author_disliked&author=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="carma_minus"><?php echo_html($user_data["carma_minus"]); ?></a>
<?php endif; ?>
</td>
</tr>

<tr>
<td><?php echo_html(text("Weighed")); ?>: <a href="search_topic.php?do_search=1&post_sort=desc&author_mode=author_liked&author=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="carma_plus"><?php echo_html(format_number($user_data["carma_plus_weighed"], 1)); ?></a>
<?php if(!empty($settings["dislikes_active"])): ?>
/ <a href="search_topic.php?do_search=1&post_sort=desc&author_mode=author_disliked&author=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="carma_minus"><?php echo_html(format_number($user_data["carma_minus_weighed"], 1)); ?></a>
<?php endif; ?>
</td>
</tr>

<?php endif; ?>

<tr>
<td></td>
</tr>

<tr>
<td><span class="number"><?php echo_html(text("Actions")); ?>:</span></td>
</tr>

<tr>
<td>
<a href="view_profile.php?uid=<?php echo_html($user_data["id"]); ?>"><?php echo_html(text("ProfilePreview")); ?></a>
</td>
</tr>

<?php if($fmanager->is_moderator_log_visible() || $fmanager->get_user_id() == reqvar("uid")): ?>
<tr>
<td><a href="user_moderation.php?uid=<?php echo_html($user_data["id"]); ?>#log"><?php echo_html(text("ModeratorLog")); ?></a></td>
</tr>
<?php endif; ?>

<tr>
<td>
<a href="user_moderation.php?uid=<?php echo_html($user_data["id"]); ?>" class="moderator_link"><?php echo_html(text("ModerateUser")); ?></a>
</td>
</tr>

<?php if($fmanager->is_admin()): ?>
<tr>
<td>
<a class="moderator_link" href="edit_user.php?uid=<?php echo_html($user_data["id"]); ?>"><?php echo_html(text("EditUser")); ?></a>
</td>
</tr>
<?php endif; ?>

<?php if($fmanager->may_see_ip()): ?>

<tr>
<td>
<a href="ip_moderation.php?type=user_ips&user=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="moderator_link"><?php echo_html(text("ShowAuthorIPs")); ?></a>
</td>
</tr>

<tr>
<td>
<a href="ip_moderation.php?type=other_users&user=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="moderator_link"><?php echo_html(text("ShowMembersOfAuthorIPs")); ?></a>
</td>
</tr>

<?php endif; ?>

<tr>
<td></td>
</tr>

<tr>
<td class="button_area">
<div class="left_buttons">
<input type="button" class="standard_button" value="<?php echo_html(text("Back")); ?>" onclick="delay_redirect('<?php echo_html($target_url); ?>')"/>
</div>
<div class="clear_both">
</div>
</td>
</tr>

</table>


<a id="moderation"></a>
<table class="rate_table">
<tr>
<th><?php echo_html(text("Member")); ?></th>
</tr>

<?php if(!empty($rate_info)): ?>
<?php foreach($rate_info as $uid => $udata): ?>
<tr>
<td>
<div class="smart_break"><a href="view_profile.php?uid=<?php echo_html($uid); ?>"><?php echo_html($udata["user_name"]); ?></a></div>

<table class="aux_table">
<tr>
<td>
<div class="forum_info">
<?php echo_html(text("Likes")); ?>:
<?php
$likes = 0;
if(!empty($udata["likes"])) $likes = $udata["likes"];
?>
<a href="search_topic.php?do_search=1&post_sort=desc&author_mode=author_liked&author=<?php echo(rawurlencode($udata["user_name"])); ?>&rated_by=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="carma_plus" ><?php echo_html($likes); ?></a>
</div>
</td>
<td>
<?php echo_html(text("Dislikes")); ?>:
<?php
$dislikes = 0;
if(!empty($udata["dislikes"])) $dislikes = $udata["dislikes"];
?>
<a href="search_topic.php?do_search=1&post_sort=desc&author_mode=author_disliked&author=<?php echo(rawurlencode($udata["user_name"])); ?>&rated_by=<?php echo(rawurlencode($user_data["user_name"])); ?>" class="carma_minus" ><?php echo_html($dislikes); ?></a>
</td>
</tr>
<tr>
<td>
<input type="text" name="to_delete[<?php echo_html($uid); ?>][likes]" placeholder="<?php echo_html(text("Delete")); ?>">
</td>
<td>
<input type="text" name="to_delete[<?php echo_html($uid); ?>][dislikes]" placeholder="<?php echo_html(text("Delete")); ?>">
</td>
</tr>
</table>

  <div class="navigation_arrows_right">
  <div class="scroll_up" onclick="window.scrollTo(0, 0);"></div>
  <div class="scroll_down" onclick="window.scrollTo(0, 1000000);"></div>
  </div>

</td>
</tr>
<?php endforeach; ?>

<tr>
<td colspan="5" class="button_area">
<div class="left_buttons">
<input type="button" class="standard_button" value="<?php echo_html(text("Back")); ?>" onclick="delay_redirect('<?php echo_html($target_url); ?>')"/>
</div>
<div class="right_buttons">
<input type="submit" class="standard_button send_button" value="<?php echo_html(text("Apply")); ?>"/>
</div>
<div class="clear_both">
</div>
</td>
</tr>

<?php else: ?>

<tr>
<td style="text-align: center"><?php echo_html(text("MsgUserNasNoRates")); ?></td>
</tr>

<?php endif; ?>

</table>

</form>

